package pawa.tp02;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

//Classe représentant le modèle
public class MovieDB {
	
	private Connection cnx;
	private int numMovies = -1;
	
	public MovieDB () throws ClassNotFoundException, SQLException 
	{
		//Chargement du driver postgresql et connexion à la base
		Class.forName("org.postgresql.Driver");
		/*conn = DriverManager.getConnection("jdbc:postgresql://tp-postgres:5433/knguye10_a", 
											"knguye10_a","knguye10_a");*/
		cnx = DriverManager.getConnection("jdbc:postgresql://localhost:5432/knguye10_a", 
				"knguye10_a","knguye10_a");
		
	}
	
	@Override
	protected void finalize()
	{
		try {
			if (cnx != null && !cnx.isClosed())
				cnx.close();
		} catch (Exception e) {}
	}
	
	public int getNumMovies() throws SQLException
	{
		
		if (numMovies == -1)
		{
			Statement s = cnx.createStatement();
			ResultSet res = s
					.executeQuery("SELECT COUNT(*) AS NUM FROM MOVIE");
			res.next();
			numMovies = res.getInt("NUM");
		}
		return numMovies;
		
	}
	
	//Méthode publique appelée depuis le Contrôleur
	public List<Pair<Integer,String>> getMovieList(int from, int to) throws SQLException
	{
		List<Pair<Integer,String>> v = new ArrayList<>();
		/* Version simple avec un Statement
		  Statement s = conn.createStatement();
		 
		ResultSet res = s.executeQuery("SELECT * FROM MOVIE ORDER BY TITLE"
							 	 	 + " LIMIT " + (to - from)
							 	 	 + " OFFSET " + from);
		*/
		/* Version avec un PreparedStatement */
		PreparedStatement stmt = cnx.prepareStatement(
				"SELECT * FROM MOVIE ORDER BY TITLE"
			  + " LIMIT ? OFFSET ?");
		stmt.setInt(1, to - from);
		stmt.setInt(2, from);
		ResultSet res = stmt.executeQuery();
		
		while (res.next())
			v.add(new Pair<>(res.getInt("MID"),res.getString("TITLE")));
	
		return v;
	}
	

	
}
